/*
  

  AutoFill in Text Box try


*/

#include "minigui.ch"

PROC Main()

   aCountries := HB_ATOKENS( MEMOREAD( "Countries.lst" ),   CRLF )
   
   ASORT( aCountries )                    // This Array MUST be sorted
       
   DEFINE WINDOW frmAFTest ;
      AT 0,0 ;
      WIDTH 550 ;
      HEIGHT 300 ;
      TITLE 'AutoFill in Text Box try' ;
      MAIN 
      
      ON KEY UP     ACTION AFNavigate( 1, "frmAFTest", "txbCountry", aCountries )
      ON KEY DOWN   ACTION AFNavigate( 2, "frmAFTest", "txbCountry", aCountries )
      
      ON KEY ESCAPE ACTION frmAFTest.Release
      
      DEFINE LABEL lblCountry
         ROW        50
         COL        50
         VALUE      "Country :"
         RIGHTALIGN .T.
         AUTOSIZE   .T.
      END LABEL // lblCountry
            
      DEFINE TEXTBOX txbCountry 
         ROW      48
         COL      110
         ONCHANGE AutoFill( "frmAFTest", this.name, this.CaretPos, aCountries )
      END TEXTBOX // txbCountry   
   
   END WINDOW // frmAFTest
   
   frmAFTest.Center
   
   frmAFTest.Activate

      
RETU // Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.


PROC AutoFill( ;                       // Setting CSBox values
                cFrmName,;   // Form / Windows name 
                cTxBName,;   // Text Box Name 
                nCarePos,;
                aList )      // Items list 
   
   LOCAL cCurval  := LEFT( GetProperty( cFrmName, cTxBName, "Value" ), nCarePos ) ,;
         n1Result := 0
                   
   IF !EMPTY( cCurval ) 
      n1Result := ASCAN( aList, { | c1 | UPPER( LEFT( c1, LEN( cCurval ) ) ) == UPPER( cCurval )} ) 
      
      IF n1Result > 0
         cCurval := aList[ n1Result ]
      ENDIF n1Result > 0
      
      SetProperty( cFrmName, cTxBName, "Value", cCurval  )        
      SetProperty( cFrmName, cTxBName, "CaretPos", nCarePos  )        
     
   ENDIF !EMPTY( cCurval ) 

RETU // SetCSBoxVal()   
   
*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.


PROC AFNavigate( ;                        // Navigation by UP/DOWN keys in AutoFill Text Box        
                 nDirect ,;  // 1 : Up, 2: Down
                 cFrmName,; 
                 cTxBName,; 
                 aList )      // Items list 

                 
   LOCAL nCarePos := GetProperty( cFrmName, cTxBName, "CaretPos"  ),;        
         n1Result := 0
                   
   LOCAL cCurval  := LEFT( GetProperty( cFrmName, cTxBName, "Value" ), nCarePos )
   
   IF !EMPTY( cCurval ) 
      n1Result := ASCAN( aList, { | c1 | UPPER( LEFT( c1, LEN( cCurval ) ) ) == UPPER( cCurval )} ) 
            
      IF n1Result > 0      
         IF nDirect < 2 
            n1Result -= IF( n1Result > 1, 1, 0 )
         ELSE
            n1Result += IF( n1Result < LEN( aList ), 1, 0 )
         ENDIF   
             
         cCurval := aList[ n1Result ]
         
      ENDIF n1Result > 0
      
      SetProperty( cFrmName, cTxBName, "Value", cCurval  )        
      SetProperty( cFrmName, cTxBName, "CaretPos", nCarePos  )        
     
   ENDIF !EMPTY( cCurval ) 

                 
RETU // AFNavigate()
 
                 
*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
                 